<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Geeklog 1.3                                                               |
// +---------------------------------------------------------------------------+
// | optimize.php                                                              |
// |                                                                           |
// | Optimize the tables of a Geeklog database.                                |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2004 by the following authors:                              |
// |                                                                           |
// | Authors: Dirk Haun - dirk@haun-online.de                                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id: optimize.php,v 1.1.1.1 2004/07/11 10:22:51 dirk Exp $

require_once ('../lib-common.php');

$display = '';

function optimizeNow ()
{
    global $_TABLES;

    $retval = '';

    $tables = '`' . implode ("`,`", $_TABLES) . "`";

    $opt_time = new timerobject ();
    $opt_time->startTimer ();

    DB_query ("OPTIMIZE TABLE $tables");

    $exectime = $opt_time->stopTimer ();

    $retval .= 'Optimizing ' . sizeof ($_TABLES) . ' tables took '
            . $exectime . ' seconds.' . LB;

    DB_query ("UPDATE {$_TABLES['vars']} SET value = NOW() WHERE name = 'lastoptimizeddb'");

    return $retval;
}

// MAIN
$mode = $HTTP_POST_VARS['mode'];
if ($mode != 'optimize') {
    $mode = '';
}

$display = '';
$display .= COM_siteHeader ('menu');

// bail if user isn't a root user
if (!SEC_inGroup ('Root')) {
    $display .= COM_startBlock($MESSAGE[30], '',
                    COM_getBlockTemplate ('_msg_block', 'header'));
    $display .= $LANG20[6];
    $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
    $display .= COM_siteFooter ();
    COM_accessLog ("User {$_USER['username']} tried to illegally access the optimize database screen.");
    echo $display;
    exit;
}

$display .= COM_startBlock ('Optimize DB tables');

$lastrun = DB_getItem ($_TABLES['vars'], 'value', "name = 'lastoptimizeddb'");
if (empty ($lastrun)) {
    DB_save ($_TABLES['vars'], 'name,value', "'lastoptimizeddb', '0000-00-00 00:00:00'");
}

if ($mode == 'optimize') {
    $display .= optimizeNow ();
} else {

    $display .= '<p>Optimize the tables in your Geeklog database.</p>' . LB;
    if (!empty ($lastrun)) {
        $display .= '<p>Last optimization: ' . $lastrun . '</p>' . LB;
    }

    $display .= '<form action="' . $PHP_SELF . '" method="POST">' . LB;
    $display .= '<input type="submit" value="Optimize Now!">' . LB;
    $display .= '<input type="hidden" value="optimize" name="mode">' . LB;
    $display .= '</form>' . LB;
}

$display .= COM_endBlock ();
$display .= COM_siteFooter ();

echo $display;

?>
